/*	**************************************************************************************
    *									overlay.js
    *									==========
    *
    *	Author:	Geva Zeichner
    *	Date:	15/04/2006
    *	Edited:	22/04/2006
    **************************************************************************************/

window.addEventListener("load", function(e){IMDb_Preview.handle_load(e);}, false);

var IMDb_Preview =
{
	/*************************************************************************************
	 *	Handle_Load(e)
	 *	==============
	 *	Listeners, var defs, inits...
	 *************************************************************************************/
	handle_load: function(e)
	{
		// Shhh... listen...
		window.addEventListener("mouseover", function(e){IMDb_Preview.handle_mouse_over(e);}, false);
		window.addEventListener("mousemove", function(e){IMDb_Preview.handle_mouse_move(e);}, false);
		
		// Set variables
		this.title_regexp = /^((http:\/\/)(www\.)?(us\.)?(uk\.)?((imdb\.com)(.*)(\/title\/tt\d{7}\/)))$/;
		this.move_timer = "";
		this.last_url_target = "";
		this.last_owner_doc = "";
		this.loaded_url = " ";
		this.http_req = new XMLHttpRequest();
		
		this.page_x = 0;
		this.page_y = 0;
		this.img = window._content.document.createElement("img");
		this.img.src = "about:blank";
		this.mydiv = window._content.document.createElement("div");
		this.mydiv.appendChild(this.img);
		
		
	},
	
	/*************************************************************************************
	 *	Handle_Mouse_Over(e)
	 *	====================
	 *	
	 *************************************************************************************/
	handle_mouse_over: function(e)
	{
		this.page_x = e.pageX;
		this.page_y = e.pageY;
		this.last_url_target = unescape(e.target.href);
		this.last_owner_doc = e.originalTarget.ownerDocument;
	},
	
	/*************************************************************************************
	 *	Handle_Mouse_Move(e)
	 *	====================
	 *	
	 *************************************************************************************/
	handle_mouse_move: function(e)
	{
		clearTimeout(this.move_timer);
		this.move_timer = setTimeout(function(){IMDb_Preview.handle_mouse_halt();}, 250);
	},
	
	/*************************************************************************************
	 *	Handle_Mouse_Halt()
	 *	===================
	 *	
	 *************************************************************************************/
	handle_mouse_halt: function()
	{
		if ((this.last_url_target != this.loaded_url) &&
			(this.last_url_target.match(this.title_regexp)))
		{
			this.load_target(this.last_url_target);
			dump("loading\n");
		}
		this.loaded_url = this.last_url_target;
	},
	
	/*************************************************************************************
	 *	Load_Target(url_target)
	 *	=======================
	 *	
	 *************************************************************************************/
	load_target: function(url_target)
	{
		this.http_req.open('GET', url_target, true);
		this.http_req.onreadystatechange = function()
		{
			// If loading completed
			if (IMDb_Preview.http_req.readyState == 4)
			IMDb_Preview.timer = setTimeout( function ()
			{
				// With no error
				if (IMDb_Preview.http_req.status == 200)
					IMDb_Preview.process_html(IMDb_Preview.http_req.responseText);
				else
					dump("Error loading page\n");
			}, 0);
		};
		this.http_req.send(null);
	},
	
	/*************************************************************************************
	 *	Process_HTML(html_source)
	 *	=========================
	 *	
	 *************************************************************************************/
	process_html: function(html_source)
	{
		var title_start_pos = html_source.indexOf('<title>', poster_pos) + 7;
		var title_end_pos = html_source.indexOf('</title>', title_start_pos);
		var title_name = html_source.substring(title_start_pos, title_end_pos);
		
		var poster_pos = html_source.indexOf('<a name="poster"');
		
		if (poster_pos == -1)
			dump("Poster Not Submitted\n\n");
		else
		{
			var img_src_start_pos = html_source.indexOf('src="', poster_pos) + 5;
			var img_src_end_pos = html_source.indexOf('" height', img_src_start_pos);
			var img_src = html_source.substring(img_src_start_pos, img_src_end_pos);
			
			dump(title_name + ":\n" + img_src + "\n\n");
			this.show_preview_img(img_src);
		}
	},
	
	/*************************************************************************************
	 *	Show_Preview_IMG(img_src)
	 *	=========================
	 *	
	 *************************************************************************************/
	show_preview_img: function(img_src)
	{
		var doc = this.last_owner_doc;
		doc.body.appendChild(this.mydiv);
		
		this.img.src = img_src;
		this.mydiv.style.position = "absolute";
		this.mydiv.style.left = this.page_x + 50 + "px";
		this.mydiv.style.top = this.page_y -50 + "px";
		this.mydiv.style.textTop = "true";
		this.mydiv.style.zIndex = "1000";
		this.img.style.visibility = "visible";
		this.mydiv.style.visibility = "visible";
	}   
};









/*url_target = unescape(e.target.href);

// If target is an IMDb title
if ((e.shiftKey) && (url_target.match(this.title_regexp)))
{
	
	// Load target's html
	
}*/




//this.status_bar = document.getElementById("statusbar-display");










